// generated by Fast Light User Interface Designer (fluid) version 1.0107

#include "PADnoteUI.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

PADnoteHarmonicProfile::PADnoteHarmonicProfile(int x,int y, int w, int h, const char *label):Fl_Box(x,y,w,h,label) {
  pars=NULL;
}

void PADnoteHarmonicProfile::init(PADnoteParameters *pars,Master *master_) {
  master=master_;
this->pars=pars;
}

void PADnoteHarmonicProfile::draw() {
  int ox=x(),oy=y(),lx=w(),ly=h();
if (!visible()) return;
REALTYPE smps[lx];

REALTYPE realbw=pars->getprofile(smps,lx);
bool active=active_r();

//draw the equivalent bandwidth
if (active) fl_color(220,220,220);
 else fl_color(160,165,165);
fl_line_style(0);
int rbw=(int)(realbw*(lx-1.0)/2.0);
for (int i=lx/2-rbw;i<(lx/2+rbw);i++) fl_line(ox+i,oy,ox+i,oy+ly-1);

fl_line_style(0);
if (active) fl_color(200,200,200);
 else  fl_color(160,160,160);
for (int i=1;i<10;i++){
	int kx=(int)(lx/10.0*i);
	fl_line(ox+kx,oy,ox+kx,oy+ly-1);
};
for (int i=1;i<5;i++){
	int ky=(int)(ly/5.0*i);
	fl_line(ox,oy+ly-ky,ox+lx,oy+ly-ky-1);
};


fl_color(120,120,120);
fl_line_style(FL_DOT);
fl_line(ox+lx/2,oy,ox+lx/2,oy+ly);

//draw the graph
fl_line_style(0);
int old=0;
for (int i=0;i<lx;i++){
   int val=(int) ((ly-2)*smps[i]);
   if (active) fl_color(180,210,240);
      else fl_color(150,150,155);
   fl_line(ox+i,oy+ly-1,ox+i,oy+ly-1-val);
   if (active) fl_color(0,0,100);
       else fl_color(150,150,150);
   if (i>0) fl_line(ox+i-1,oy+ly-2-old,ox+i,oy+ly-2-val);
   old=val;   
};


fl_line_style(FL_DASH);
if (active) fl_color(0,100,220);
    else fl_color(150,160,170);
fl_line(ox+lx/2-rbw,oy,ox+lx/2-rbw,oy+ly-1);
fl_line(ox+lx/2+rbw,oy,ox+lx/2+rbw,oy+ly-1);

fl_line_style(0);
}

PADnoteOvertonePosition::PADnoteOvertonePosition(int x,int y, int w, int h, const char *label):Fl_Box(x,y,w,h,label) {
  pars=NULL;
}

void PADnoteOvertonePosition::init(PADnoteParameters *pars,Master *master_) {
  master=master_;
this->pars=pars;
}

void PADnoteOvertonePosition::draw() {
  if (!visible()) return;
const int maxdb=60;

int ox=x(),oy=y(),lx=w(),ly=h();
const int maxharmonic=64;


for (int i=1;i<maxharmonic;i++){
	fl_color(200,200,200);
	fl_line_style(FL_DOT);
	if (i%5==0) fl_line_style(0);
	if (i%10==0) fl_color(160,160,160);
	int kx=(int)(lx/(REALTYPE)maxharmonic*i);
	fl_line(ox+kx,oy,ox+kx,oy+ly);
};



int n=OSCIL_SIZE/2;
REALTYPE spc[n];
for (int i=0;i<n;i++) spc[i]=0.0;

pthread_mutex_lock(&master->mutex);
pars->oscilgen->getspectrum(n,spc,0);
pthread_mutex_unlock(&master->mutex);


//normalize
REALTYPE max=0;
for (int i=0;i<n;i++){
   REALTYPE x=fabs(spc[i]);
   if (max<x) max=x;
}
if (max<0.000001) max=1.0;
max=max*1.05;

REALTYPE spectrum[lx];
for (int i=0;i<lx;i++) spectrum[i]=0;


for (int i=1;i<n;i++){
	REALTYPE nhr=pars->getNhr(i);
	int kx=(int)(lx/(REALTYPE)maxharmonic*nhr);
	if ((kx<0)||(kx>lx)) continue;

        spectrum[kx]=spc[i-1]/max+1e-9;

};

fl_color(180,0,0);
fl_line_style(0);

if (pars->Pmode==2){
   int old=0;
   for (int i=1;i<lx;i++){
	if ((spectrum[i]>1e-10)||(i==(lx-1))){
		int delta=i-old;
		REALTYPE val1=spectrum[old];
		REALTYPE val2=spectrum[i];

		REALTYPE idelta=1.0/delta;
		for (int j=0;j<delta;j++){
			REALTYPE x=idelta*j;
			spectrum[old+j]=val1*(1.0-x)+val2*x;
		};
		old=i;
	};
      
   };
};

for (int i=0;i<lx;i++){
	REALTYPE x=spectrum[i];
        if (x>dB2rap(-maxdb)) x=rap2dB(x)/maxdb+1;
             else continue;
       	int yy=(int)(x*ly);
	fl_line(ox+i,oy+ly-1-yy,ox+i,oy+ly-1);
      
};
}

void PADnoteUI::cb__i(Fl_Tabs* o, void*) {
  if (o->value()!=harmonicstructuregroup) applybutton->hide();
	else applybutton->show();
}
void PADnoteUI::cb_(Fl_Tabs* o, void* v) {
  ((PADnoteUI*)(o->parent()->user_data()))->cb__i(o,v);
}

void PADnoteUI::cb_hpbasepar1_i(WidgetPDial* o, void*) {
  pars->Php.base.par1=(int) o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpbasepar1(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hpbasepar1_i(o,v);
}

void PADnoteUI::cb_hpbasetype_i(Fl_Choice* o, void*) {
  pars->Php.base.type=o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpbasetype(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hpbasetype_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_hpbasetype[] = {
 {"Gauss", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Square", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"DoubleExp", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_hpfreqmult_i(WidgetPDial* o, void*) {
  pars->Php.freqmult=(int) o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpfreqmult(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hpfreqmult_i(o,v);
}

void PADnoteUI::cb_hpmpar1_i(WidgetPDial* o, void*) {
  pars->Php.modulator.par1=(int) o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpmpar1(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hpmpar1_i(o,v);
}

void PADnoteUI::cb_hpmfreq_i(WidgetPDial* o, void*) {
  pars->Php.modulator.freq=(int) o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpmfreq(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hpmfreq_i(o,v);
}

void PADnoteUI::cb_hpamptype_i(Fl_Choice* o, void*) {
  pars->Php.amp.type=o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpamptype(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_hpamptype_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_hpamptype[] = {
 {"OFF", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Gauss", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Sine", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Flat", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_hpampmode_i(Fl_Choice* o, void*) {
  pars->Php.amp.mode=o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpampmode(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_hpampmode_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_hpampmode[] = {
 {"Sum", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Mult", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Div1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Div2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_hpamppar1_i(WidgetPDial* o, void*) {
  pars->Php.amp.par1=(int) o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpamppar1(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_hpamppar1_i(o,v);
}

void PADnoteUI::cb_hpamppar2_i(WidgetPDial* o, void*) {
  pars->Php.amp.par2=(int) o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpamppar2(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_hpamppar2_i(o,v);
}

void PADnoteUI::cb_hpautoscale_i(Fl_Check_Button* o, void*) {
  pars->Php.autoscale=(int) o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpautoscale(Fl_Check_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hpautoscale_i(o,v);
}

void PADnoteUI::cb_hponehalf_i(Fl_Choice* o, void*) {
  pars->Php.onehalf=o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hponehalf(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hponehalf_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_hponehalf[] = {
 {"Full", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Upper Half", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Lower Half", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_hpwidth_i(WidgetPDial* o, void*) {
  pars->Php.width=(int) o->value();
hprofile->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hpwidth(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hpwidth_i(o,v);
}

void PADnoteUI::cb_Change_i(Fl_Button*, void*) {
  if (oscui!=NULL) delete (oscui);
oscui=new OscilEditor(pars->oscilgen,osc,cbwidget,applybutton,master);
}
void PADnoteUI::cb_Change(Fl_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_Change_i(o,v);
}

void PADnoteUI::cb_cbwidget_i(Fl_Box*, void*) {
  overtonepos->redraw();
applybutton->color(FL_RED);
applybutton->redraw();
}
void PADnoteUI::cb_cbwidget(Fl_Box* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_cbwidget_i(o,v);
}

void PADnoteUI::cb_Resonance_i(Fl_Button*, void*) {
  resui->resonancewindow->redraw();
resui->resonancewindow->show();
resui->setcbwidget(cbwidget,applybutton);
}
void PADnoteUI::cb_Resonance(Fl_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_Resonance_i(o,v);
}

void PADnoteUI::cb_bwdial_i(WidgetPDial* o, void*) {
  bwcents->value(pars->setPbandwidth((int) o->value()));
cbwidget->do_callback();
}
void PADnoteUI::cb_bwdial(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_bwdial_i(o,v);
}

void PADnoteUI::cb_hrpostype_i(Fl_Choice* o, void*) {
  pars->Phrpos.type=o->value();
overtonepos->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hrpostype(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hrpostype_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_hrpostype[] = {
 {"Harmonic", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"ShiftU", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"ShiftL", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"PowerU", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"PowerL", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"Sine", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"Power", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_hrpospar1_i(WidgetPDial* o, void*) {
  pars->Phrpos.par1=(int) o->value();
overtonepos->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hrpospar1(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hrpospar1_i(o,v);
}

void PADnoteUI::cb_hrpospar2_i(WidgetPDial* o, void*) {
  pars->Phrpos.par2=(int) o->value();
overtonepos->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hrpospar2(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hrpospar2_i(o,v);
}

void PADnoteUI::cb_hrpospar3_i(WidgetPDial* o, void*) {
  pars->Phrpos.par3=(int) o->value();
overtonepos->redraw();
cbwidget->do_callback();
}
void PADnoteUI::cb_hrpospar3(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hrpospar3_i(o,v);
}

void PADnoteUI::cb_bwscale_i(Fl_Choice* o, void*) {
  pars->Pbwscale=(int) o->value();
cbwidget->do_callback();
}
void PADnoteUI::cb_bwscale(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_bwscale_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_bwscale[] = {
 {"Normal", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"EqualHz", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"Quater", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"Half", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"75%", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"150%", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"Double", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"Inv.Half", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_qsamplesize_i(Fl_Choice* o, void*) {
  pars->Pquality.samplesize=(int) o->value();
cbwidget->do_callback();
}
void PADnoteUI::cb_qsamplesize(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_qsamplesize_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_qsamplesize[] = {
 {"16k (Tiny)", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"32k", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"64k (Small)", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"128k", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"256k (Normal)", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"512k", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"1M (Big)", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_qsmpoct_i(Fl_Choice* o, void*) {
  pars->Pquality.smpoct=(int) o->value();
cbwidget->do_callback();
}
void PADnoteUI::cb_qsmpoct(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_qsmpoct_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_qsmpoct[] = {
 {"0.5", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"6", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"12", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_qoct_i(Fl_Choice* o, void*) {
  pars->Pquality.oct=(int) o->value();
cbwidget->do_callback();
}
void PADnoteUI::cb_qoct(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_qoct_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_qoct[] = {
 {"1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"5", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"6", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"7", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"8", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_qbasenote_i(Fl_Choice* o, void*) {
  pars->Pquality.basenote=(int) o->value();
cbwidget->do_callback();
}
void PADnoteUI::cb_qbasenote(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_qbasenote_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_qbasenote[] = {
 {"C-2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"G-2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"C-3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"G-3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"C-4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"G-4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"C-5", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"G-5", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"G-6", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_spectrummode_i(Fl_Choice* o, void*) {
  pars->Pmode=(int) o->value();

if (pars->Pmode==0){
   bwprofilegroup->activate();
   bwdial->activate();
   bwcents->activate();
   hprofile->activate();
   hprofile->color(54);
   bwscale->activate();
} else {
   bwprofilegroup->deactivate();
   bwdial->deactivate();
   bwcents->deactivate();
   hprofile->deactivate();
   hprofile->color(48);
   bwscale->deactivate();
};

cbwidget->do_callback();
}
void PADnoteUI::cb_spectrummode(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->user_data()))->cb_spectrummode_i(o,v);
}

Fl_Menu_Item PADnoteUI::menu_spectrummode[] = {
 {"Bandwidth", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"Discrete", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {"Continous", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PADnoteUI::cb_octave_i(Fl_Counter* o, void*) {
  int k=(int) o->value();
if (k<0) k+=16;
pars->PCoarseDetune = k*1024+
   pars->PCoarseDetune%1024;
}
void PADnoteUI::cb_octave(Fl_Counter* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_octave_i(o,v);
}

void PADnoteUI::cb_coarsedet_i(Fl_Counter* o, void*) {
  int k=(int) o->value();
if (k<0) k+=1024;
pars->PCoarseDetune = k+
   (pars->PCoarseDetune/1024)*1024;
}
void PADnoteUI::cb_coarsedet(Fl_Counter* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_coarsedet_i(o,v);
}

void PADnoteUI::cb_detune_i(Fl_Slider* o, void*) {
  pars->PDetune=(int)o->value()+8192;
detunevalueoutput->do_callback();
}
void PADnoteUI::cb_detune(Fl_Slider* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_detune_i(o,v);
}

void PADnoteUI::cb_detunevalueoutput_i(Fl_Value_Output* o, void*) {
  o->value(getdetune(pars->PDetuneType,0,pars->PDetune));
}
void PADnoteUI::cb_detunevalueoutput(Fl_Value_Output* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_detunevalueoutput_i(o,v);
}

void PADnoteUI::cb_detunetype_i(Fl_Choice* o, void*) {
  pars->PDetuneType=(int) o->value()+1;
detunevalueoutput->do_callback();
}
void PADnoteUI::cb_detunetype(Fl_Choice* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_detunetype_i(o,v);
}

void PADnoteUI::cb_hz440_i(Fl_Check_Button* o, void*) {
  int x=(int) o->value();
pars->Pfixedfreq=x;
if (x==0) fixedfreqetdial->deactivate();
   else fixedfreqetdial->activate();
}
void PADnoteUI::cb_hz440(Fl_Check_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_hz440_i(o,v);
}

void PADnoteUI::cb_fixedfreqetdial_i(WidgetPDial* o, void*) {
  pars->PfixedfreqET=(int) o->value();
}
void PADnoteUI::cb_fixedfreqetdial(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_fixedfreqetdial_i(o,v);
}

void PADnoteUI::cb_volume_i(Fl_Value_Slider* o, void*) {
  pars->PVolume=(int)o->value();
}
void PADnoteUI::cb_volume(Fl_Value_Slider* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_volume_i(o,v);
}

void PADnoteUI::cb_vsns_i(Fl_Value_Slider* o, void*) {
  pars->PAmpVelocityScaleFunction=(int) o->value();
}
void PADnoteUI::cb_vsns(Fl_Value_Slider* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_vsns_i(o,v);
}

void PADnoteUI::cb_pan_i(WidgetPDial* o, void*) {
  pars->PPanning=(int) o->value();
}
void PADnoteUI::cb_pan(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_pan_i(o,v);
}

void PADnoteUI::cb_pstr_i(WidgetPDial* o, void*) {
  pars->PPunchStrength=(int) o->value();
}
void PADnoteUI::cb_pstr(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_pstr_i(o,v);
}

void PADnoteUI::cb_pt_i(WidgetPDial* o, void*) {
  pars->PPunchTime=(int) o->value();
}
void PADnoteUI::cb_pt(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_pt_i(o,v);
}

void PADnoteUI::cb_pstc_i(WidgetPDial* o, void*) {
  pars->PPunchStretch=(int) o->value();
}
void PADnoteUI::cb_pstc(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_pstc_i(o,v);
}

void PADnoteUI::cb_pvel_i(WidgetPDial* o, void*) {
  pars->PPunchVelocitySensing=(int) o->value();
}
void PADnoteUI::cb_pvel(WidgetPDial* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_pvel_i(o,v);
}

void PADnoteUI::cb_stereo_i(Fl_Check_Button* o, void*) {
  pars->PStereo=(int) o->value();
hprofile->redraw();
}
void PADnoteUI::cb_stereo(Fl_Check_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_stereo_i(o,v);
}

void PADnoteUI::cb_applybutton_i(Fl_Button* o, void*) {
  pars->applyparameters(true);
o->color(FL_GRAY);
if (oscui!=NULL) {
	oscui->applybutton->color(FL_GRAY);
	oscui->applybutton->redraw();
};
if (resui!=NULL) {
	resui->applybutton->color(FL_GRAY);
	resui->applybutton->redraw();
};
}
void PADnoteUI::cb_applybutton(Fl_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->user_data()))->cb_applybutton_i(o,v);
}

void PADnoteUI::cb_Close_i(Fl_Button*, void*) {
  padnotewindow->hide();
}
void PADnoteUI::cb_Close(Fl_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void PADnoteUI::cb_C_i(Fl_Button*, void*) {
  presetsui->copy(pars);
}
void PADnoteUI::cb_C(Fl_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->user_data()))->cb_C_i(o,v);
}

void PADnoteUI::cb_P_i(Fl_Button*, void*) {
  presetsui->paste(pars,this);
}
void PADnoteUI::cb_P(Fl_Button* o, void* v) {
  ((PADnoteUI*)(o->parent()->user_data()))->cb_P_i(o,v);
}

PADnoteUI::PADnoteUI(PADnoteParameters *parameters,Master *master_) {
  pars=parameters;
master=master_;
oscui=NULL;
resui=new ResonanceUI(pars->resonance);
make_window();
}

Fl_Double_Window* PADnoteUI::make_window() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = padnotewindow = new Fl_Double_Window(535, 450, "PAD synth Parameters");
    w = o;
    o->user_data((void*)(this));
    { Fl_Tabs* o = new Fl_Tabs(0, 0, 535, 395);
      o->callback((Fl_Callback*)cb_);
      { Fl_Group* o = harmonicstructuregroup = new Fl_Group(0, 20, 535, 375, "Harmonic Structure");
        o->box(FL_ENGRAVED_BOX);
        { Fl_Group* o = bwprofilegroup = new Fl_Group(5, 30, 90, 260);
          o->box(FL_ENGRAVED_BOX);
          { WidgetPDial* o = hpbasepar1 = new WidgetPDial(20, 75, 25, 25, "Width");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_hpbasepar1);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->Php.base.par1);
          }
          { Fl_Choice* o = hpbasetype = new Fl_Choice(15, 45, 75, 15, "Base Type");
            o->down_box(FL_BORDER_BOX);
            o->labelsize(10);
            o->textsize(10);
            o->callback((Fl_Callback*)cb_hpbasetype);
            o->align(FL_ALIGN_TOP_LEFT);
            o->menu(menu_hpbasetype);
            o->value(pars->Php.base.type);
          }
          { WidgetPDial* o = hpfreqmult = new WidgetPDial(55, 75, 25, 25, "FreqMlt");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_hpfreqmult);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->Php.freqmult);
          }
          { WidgetPDial* o = hpmpar1 = new WidgetPDial(15, 115, 20, 20, "Str");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_hpmpar1);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->Php.modulator.par1);
          }
          { WidgetPDial* o = hpmfreq = new WidgetPDial(40, 115, 20, 20, "SFreq");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_hpmfreq);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->Php.modulator.freq);
          }
          { Fl_Group* o = new Fl_Group(10, 160, 80, 105);
            o->box(FL_BORDER_BOX);
            { Fl_Choice* o = hpamptype = new Fl_Choice(15, 175, 70, 15, "AmpMultiplier");
              o->down_box(FL_BORDER_BOX);
              o->labelsize(10);
              o->textsize(10);
              o->callback((Fl_Callback*)cb_hpamptype);
              o->align(FL_ALIGN_TOP_LEFT);
              o->menu(menu_hpamptype);
              o->value(pars->Php.amp.type);
            }
            { Fl_Choice* o = hpampmode = new Fl_Choice(15, 205, 70, 15, "AmpMode");
              o->down_box(FL_BORDER_BOX);
              o->labelsize(10);
              o->textsize(10);
              o->callback((Fl_Callback*)cb_hpampmode);
              o->align(FL_ALIGN_TOP_LEFT);
              o->menu(menu_hpampmode);
              o->value(pars->Php.amp.mode);
            }
            { WidgetPDial* o = hpamppar1 = new WidgetPDial(15, 235, 25, 25, "Par1");
              o->box(FL_ROUND_UP_BOX);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_INACTIVE_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(11);
              o->labelcolor(FL_FOREGROUND_COLOR);
              o->maximum(127);
              o->step(1);
              o->callback((Fl_Callback*)cb_hpamppar1);
              o->align(FL_ALIGN_TOP);
              o->when(FL_WHEN_CHANGED);
              o->value(pars->Php.amp.par1);
            }
            { WidgetPDial* o = hpamppar2 = new WidgetPDial(55, 235, 25, 25, "Par2");
              o->box(FL_ROUND_UP_BOX);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_INACTIVE_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(11);
              o->labelcolor(FL_FOREGROUND_COLOR);
              o->maximum(127);
              o->step(1);
              o->callback((Fl_Callback*)cb_hpamppar2);
              o->align(FL_ALIGN_TOP);
              o->when(FL_WHEN_CHANGED);
              o->value(pars->Php.amp.par2);
            }
            o->end();
          }
          { Fl_Check_Button* o = hpautoscale = new Fl_Check_Button(10, 270, 60, 15, "autoscale");
            o->down_box(FL_DOWN_BOX);
            o->labelsize(10);
            o->callback((Fl_Callback*)cb_hpautoscale);
            o->value(pars->Php.autoscale);
          }
          { Fl_Choice* o = hponehalf = new Fl_Choice(10, 143, 80, 15);
            o->down_box(FL_BORDER_BOX);
            o->labelsize(10);
            o->textsize(10);
            o->callback((Fl_Callback*)cb_hponehalf);
            o->align(FL_ALIGN_TOP_LEFT);
            o->menu(menu_hponehalf);
            o->value(pars->Php.onehalf);
          }
          { WidgetPDial* o = hpwidth = new WidgetPDial(65, 115, 20, 20, "Size");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_hpwidth);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->Php.width);
          }
          if (pars->Pmode!=0) o->deactivate();
          o->end();
        }
        { Fl_Group* o = new Fl_Group(100, 155, 270, 135);
          o->box(FL_THIN_DOWN_BOX);
          o->color(FL_GRAY0);
          o->selection_color((Fl_Color)71);
          o->labelcolor((Fl_Color)179);
          o->align(FL_ALIGN_BOTTOM_LEFT);
          osc=new Oscilloscope(o->x(),o->y(),o->w(),o->h(),"");
          osc->init(pars->oscilgen,master);
          o->end();
        }
        { Fl_Button* o = new Fl_Button(375, 270, 60, 20, "Change");
          o->box(FL_THIN_UP_BOX);
          o->labelfont(1);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Change);
        }
        { Fl_Box* o = cbwidget = new Fl_Box(125, 135, 205, 20, "Harmonic Content");
          o->callback((Fl_Callback*)cb_cbwidget);
          o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
        }
        { Fl_Button* o = new Fl_Button(375, 225, 80, 20, "Resonance");
          o->box(FL_THIN_UP_BOX);
          o->callback((Fl_Callback*)cb_Resonance);
        }
        { WidgetPDial* o = bwdial = new WidgetPDial(15, 295, 35, 35, "BandWidth");
          o->box(FL_ROUND_UP_BOX);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color(FL_INACTIVE_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(11);
          o->labelcolor(FL_FOREGROUND_COLOR);
          o->maximum(1000);
          o->step(1);
          o->callback((Fl_Callback*)cb_bwdial);
          o->align(FL_ALIGN_BOTTOM);
          o->when(FL_WHEN_CHANGED);
          o->value(pars->Pbandwidth);
          if (pars->Pmode!=0) o->deactivate();
        }
        { Fl_Value_Output* o = bwcents = new Fl_Value_Output(55, 305, 55, 15, "cents");
          o->labelsize(10);
          o->maximum(10000);
          o->step(0.1);
          o->align(FL_ALIGN_BOTTOM_LEFT);
          o->value(pars->setPbandwidth(pars->Pbandwidth));
          if (pars->Pmode!=0) o->deactivate();
        }
        { Fl_Group* o = new Fl_Group(315, 295, 215, 45);
          o->box(FL_ENGRAVED_BOX);
          { Fl_Choice* o = hrpostype = new Fl_Choice(325, 310, 80, 20, "OvertonesPosition");
            o->down_box(FL_BORDER_BOX);
            o->labelsize(10);
            o->textsize(12);
            o->callback((Fl_Callback*)cb_hrpostype);
            o->align(FL_ALIGN_TOP_LEFT);
            o->menu(menu_hrpostype);
            o->value(pars->Phrpos.type);
          }
          { WidgetPDial* o = hrpospar1 = new WidgetPDial(425, 310, 25, 25, "Par1");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(255);
            o->step(1);
            o->callback((Fl_Callback*)cb_hrpospar1);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->Phrpos.par1);
          }
          { WidgetPDial* o = hrpospar2 = new WidgetPDial(460, 310, 25, 25, "Par2");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(255);
            o->step(1);
            o->callback((Fl_Callback*)cb_hrpospar2);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->Phrpos.par2);
          }
          { WidgetPDial* o = hrpospar3 = new WidgetPDial(495, 310, 25, 25, "ForceH");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(255);
            o->step(1);
            o->callback((Fl_Callback*)cb_hrpospar3);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->Phrpos.par3);
          }
          o->end();
        }
        { Fl_Choice* o = bwscale = new Fl_Choice(120, 305, 80, 20, "Bandwidth Scale");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(10);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_bwscale);
          o->align(FL_ALIGN_TOP_LEFT);
          o->menu(menu_bwscale);
          o->value(pars->Pbwscale);
          if (pars->Pmode!=0) o->deactivate();
        }
        { Fl_Group* o = overtonepos = new Fl_Group(5, 345, 525, 45);
          o->box(FL_FLAT_BOX);
          o->color(FL_LIGHT3);
          o->selection_color((Fl_Color)218);
          o->labelcolor(FL_GREEN);
          PADnoteOvertonePosition *opui=new PADnoteOvertonePosition(o->x(),o->y(),o->w(),o->h(),"");
          opui->init(pars,master);
          o->end();
        }
        { Fl_Choice* o = qsamplesize = new Fl_Choice(375, 190, 115, 20, "Sample Size");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(10);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_qsamplesize);
          o->align(FL_ALIGN_TOP_LEFT);
          o->menu(menu_qsamplesize);
          o->value(pars->Pquality.samplesize);
        }
        { Fl_Choice* o = qsmpoct = new Fl_Choice(430, 155, 45, 20, "smp/oct");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_qsmpoct);
          o->align(FL_ALIGN_TOP_LEFT);
          o->menu(menu_qsmpoct);
          o->value(pars->Pquality.smpoct);
        }
        { Fl_Choice* o = qoct = new Fl_Choice(480, 155, 45, 20, "no.oct");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_qoct);
          o->align(FL_ALIGN_TOP_LEFT);
          o->menu(menu_qoct);
          o->value(pars->Pquality.oct);
        }
        { Fl_Choice* o = qbasenote = new Fl_Choice(375, 155, 50, 20, "base");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_qbasenote);
          o->align(FL_ALIGN_TOP_LEFT);
          o->menu(menu_qbasenote);
          o->value(pars->Pquality.basenote);
        }
        { Fl_Group* o = hprofile = new Fl_Group(100, 45, 430, 90);
          o->box(FL_FLAT_BOX);
          o->color(FL_LIGHT3);
          o->selection_color((Fl_Color)218);
          o->labelcolor(FL_GREEN);
          PADnoteHarmonicProfile *hpui=new PADnoteHarmonicProfile(o->x(),o->y(),o->w(),o->h(),"");
          hpui->init(pars,master);
          if (pars->Pmode!=0) { o->deactivate(); o->color(48);};
          o->end();
        }
        new Fl_Box(160, 25, 315, 20, "Profile of One Harmonic (Frequency Distribution)");
        { Fl_Choice* o = spectrummode = new Fl_Choice(220, 305, 90, 20, "Spectrum Mode");
          o->down_box(FL_BORDER_BOX);
          o->labelfont(1);
          o->labelsize(10);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_spectrummode);
          o->align(FL_ALIGN_TOP_LEFT);
          o->menu(menu_spectrummode);
          o->value(pars->Pmode);
        }
        o->end();
      }
      { Fl_Group* o = new Fl_Group(0, 20, 535, 375, "Envelopes&LFOs");
        o->box(FL_ENGRAVED_BOX);
        o->hide();
        { Fl_Group* o = new Fl_Group(5, 275, 525, 115, "FREQUENCY");
          o->box(FL_THIN_UP_BOX);
          o->labeltype(FL_EMBOSSED_LABEL);
          o->labelfont(1);
          o->labelsize(16);
          o->align(FL_ALIGN_TOP|FL_ALIGN_INSIDE);
          { EnvelopeUI* o = freqenv = new EnvelopeUI(10, 315, 205, 70, "PADSynth - Frequency Envelope");
            o->box(FL_FLAT_BOX);
            o->color((Fl_Color)51);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
            o->when(FL_WHEN_RELEASE);
            o->init(pars->FreqEnvelope);
            o->end();
          }
          { Fl_Counter* o = octave = new Fl_Counter(470, 295, 45, 15, "Octave");
            o->tooltip("Octave");
            o->type(1);
            o->labelsize(10);
            o->minimum(-8);
            o->maximum(7);
            o->step(1);
            o->textfont(1);
            o->textsize(12);
            o->callback((Fl_Callback*)cb_octave);
            o->align(FL_ALIGN_TOP);
            int k=pars->PCoarseDetune/1024;
            if (k>=8) k-=16;
            o->value(k);
          }
          { Fl_Counter* o = coarsedet = new Fl_Counter(455, 365, 60, 20, "Coarse det.");
            o->tooltip("Coarse Detune");
            o->labelsize(10);
            o->minimum(-64);
            o->maximum(63);
            o->step(1);
            o->textfont(1);
            o->textsize(12);
            o->callback((Fl_Callback*)cb_coarsedet);
            o->align(FL_ALIGN_TOP_LEFT);
            int k=pars->PCoarseDetune%1024;
            if (k>=512) k-=1024;
            o->value(k);
            o->lstep(10);
          }
          { LFOUI* o = freqlfo = new LFOUI(215, 315, 230, 70, "Frequency LFO     ");
            o->box(FL_FLAT_BOX);
            o->color(FL_DARK1);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
            o->when(FL_WHEN_RELEASE);
            o->init(pars->FreqLfo);
            o->end();
          }
          { Fl_Slider* o = detune = new Fl_Slider(60, 295, 295, 15);
            o->tooltip("Fine Detune (cents)");
            o->type(5);
            o->box(FL_FLAT_BOX);
            o->minimum(-8192);
            o->maximum(8191);
            o->step(1);
            o->callback((Fl_Callback*)cb_detune);
            o->value(pars->PDetune-8192);
          }
          { Fl_Value_Output* o = detunevalueoutput = new Fl_Value_Output(12, 295, 45, 15, "Detune");
            o->labelsize(10);
            o->minimum(-5000);
            o->maximum(5000);
            o->step(0.01);
            o->textfont(1);
            o->textsize(10);
            o->callback((Fl_Callback*)cb_detunevalueoutput);
            o->align(FL_ALIGN_TOP_LEFT);
            o->value(getdetune(pars->PDetuneType,0,pars->PDetune));
          }
          { Fl_Choice* o = detunetype = new Fl_Choice(450, 335, 75, 15, "Detune Type");
            o->down_box(FL_BORDER_BOX);
            o->labelsize(10);
            o->textfont(1);
            o->textsize(10);
            o->callback((Fl_Callback*)cb_detunetype);
            o->align(FL_ALIGN_TOP_LEFT);
            o->add("L35cents");o->add("L10cents");o->add("E100cents");o->add("E1200cents");
            o->value(pars->PDetuneType-1);
          }
          { Fl_Check_Button* o = hz440 = new Fl_Check_Button(365, 295, 50, 15, "440Hz");
            o->tooltip("set the base frequency to 440Hz");
            o->down_box(FL_DOWN_BOX);
            o->labelfont(1);
            o->labelsize(11);
            o->callback((Fl_Callback*)cb_hz440);
            o->value(pars->Pfixedfreq);
          }
          { WidgetPDial* o = fixedfreqetdial = new WidgetPDial(420, 295, 15, 15, "Eq.T.");
            o->tooltip("How the frequency varies acording to the keyboard (leftmost for fixed frequen\
cy)");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(10);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_fixedfreqetdial);
            o->align(FL_ALIGN_RIGHT);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->PfixedfreqET);
            if (pars->Pfixedfreq==0) o->deactivate();
          }
          o->end();
        }
        { Fl_Group* o = new Fl_Group(5, 25, 240, 250, "AMPLITUDE");
          o->box(FL_THIN_UP_FRAME);
          o->labeltype(FL_EMBOSSED_LABEL);
          o->labelfont(1);
          o->labelsize(16);
          o->align(FL_ALIGN_TOP|FL_ALIGN_INSIDE);
          { Fl_Value_Slider* o = volume = new Fl_Value_Slider(10, 50, 160, 15, "Vol");
            o->tooltip("Volume");
            o->type(5);
            o->box(FL_FLAT_BOX);
            o->labelsize(12);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_volume);
            o->align(FL_ALIGN_RIGHT);
            o->value(pars->PVolume);
          }
          { Fl_Value_Slider* o = vsns = new Fl_Value_Slider(10, 70, 160, 15, "V.Sns");
            o->tooltip("Velocity Sensing Function (rightmost to disable)");
            o->type(5);
            o->box(FL_FLAT_BOX);
            o->labelsize(12);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_vsns);
            o->align(FL_ALIGN_RIGHT);
            o->value(pars->PAmpVelocityScaleFunction);
          }
          { WidgetPDial* o = pan = new WidgetPDial(210, 45, 30, 30, "Pan");
            o->tooltip("Panning (leftmost is Random)");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_pan);
            o->align(FL_ALIGN_BOTTOM);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->PPanning);
          }
          { WidgetPDial* o = pstr = new WidgetPDial(125, 247, 25, 25, "P.Str.");
            o->tooltip("Punch Strength");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_pstr);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->PPunchStrength);
          }
          { WidgetPDial* o = pt = new WidgetPDial(155, 247, 25, 25, "P.t.");
            o->tooltip("Punch Time (duration)");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_pt);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->PPunchTime);
          }
          { WidgetPDial* o = pstc = new WidgetPDial(185, 247, 25, 25, "P.Stc.");
            o->tooltip("Punch Stretch");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_pstc);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->PPunchStretch);
          }
          { WidgetPDial* o = pvel = new WidgetPDial(215, 247, 25, 25, "P.Vel.");
            o->tooltip("Punch Velocity Sensing");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(11);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_pvel);
            o->align(FL_ALIGN_TOP);
            o->when(FL_WHEN_CHANGED);
            o->value(pars->PPunchVelocitySensing);
          }
          { EnvelopeUI* o = ampenv = new EnvelopeUI(10, 95, 205, 70, "PADSynth - Amplitude Envelope");
            o->box(FL_FLAT_BOX);
            o->color((Fl_Color)51);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
            o->when(FL_WHEN_RELEASE);
            o->init(pars->AmpEnvelope);
            o->end();
          }
          { LFOUI* o = amplfo = new LFOUI(10, 165, 230, 70, "Amplitude LFO     ");
            o->box(FL_FLAT_BOX);
            o->color(FL_DARK1);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
            o->when(FL_WHEN_RELEASE);
            o->init(pars->AmpLfo);
            o->end();
          }
          { Fl_Check_Button* o = stereo = new Fl_Check_Button(15, 245, 70, 25, "Stereo");
            o->down_box(FL_DOWN_BOX);
            o->callback((Fl_Callback*)cb_stereo);
            o->value(pars->PStereo);
          }
          o->end();
        }
        { Fl_Group* o = new Fl_Group(245, 25, 285, 250, "FILTER");
          o->box(FL_THIN_UP_BOX);
          o->labeltype(FL_EMBOSSED_LABEL);
          o->labelfont(1);
          o->labelsize(16);
          o->align(FL_ALIGN_TOP|FL_ALIGN_INSIDE);
          { EnvelopeUI* o = filterenv = new EnvelopeUI(250, 130, 275, 70, "PADSynth - Filter Envelope");
            o->box(FL_FLAT_BOX);
            o->color((Fl_Color)51);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
            o->when(FL_WHEN_RELEASE);
            o->init(pars->FilterEnvelope);
            o->end();
          }
          { LFOUI* o = filterlfo = new LFOUI(250, 200, 230, 70, "Filter LFO     ");
            o->box(FL_FLAT_BOX);
            o->color(FL_DARK1);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
            o->when(FL_WHEN_RELEASE);
            o->init(pars->FilterLfo);
            o->end();
          }
          { FilterUI* o = filterui = new FilterUI(250, 55, 275, 75, "PADsynth - Filter");
            o->box(FL_FLAT_BOX);
            o->color(FL_LIGHT1);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
            o->when(FL_WHEN_RELEASE);
            o->init(pars->GlobalFilter,&pars->PFilterVelocityScale,&pars->PFilterVelocityScaleFunction);
            o->end();
          }
          o->end();
        }
        o->end();
      }
      o->end();
    }
    { Fl_Button* o = applybutton = new Fl_Button(45, 405, 185, 40, "Apply Changes");
      o->box(FL_THIN_UP_BOX);
      o->labelfont(1);
      o->labelsize(23);
      o->callback((Fl_Callback*)cb_applybutton);
      o->color(FL_RED);
    }
    { Fl_Button* o = new Fl_Button(320, 405, 175, 40, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(20);
      o->callback((Fl_Callback*)cb_Close);
    }
    { Fl_Button* o = new Fl_Button(240, 430, 25, 15, "C");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_C);
    }
    { Fl_Button* o = new Fl_Button(270, 430, 25, 15, "P");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_P);
    }
    o->end();
  }
  return w;
}

void PADnoteUI::refresh() {
  volume->value(pars->PVolume);
vsns->value(pars->PAmpVelocityScaleFunction);
pan->value(pars->PPanning);

stereo->value(pars->PStereo);


pstr->value(pars->PPunchStrength);
pt->value(pars->PPunchTime);
pstc->value(pars->PPunchStretch);
pvel->value(pars->PPunchVelocitySensing);

detunevalueoutput->value(getdetune(pars->PDetuneType,0,pars->PDetune));
detune->value(pars->PDetune-8192);

int k=pars->PCoarseDetune/1024;if (k>=8) k-=16;
octave->value(k);

detunetype->value(pars->PDetuneType-1);
k=pars->PCoarseDetune%1024;if (k>=512) k-=1024;
coarsedet->value(k);

hz440->value(pars->Pfixedfreq);
fixedfreqetdial->value(pars->PfixedfreqET);

amplfo->refresh();
freqlfo->refresh();
filterlfo->refresh();

ampenv->refresh();
freqenv->refresh();
filterenv->refresh();
filterui->refresh();


/* harmonic structure parametrs */

resui->refresh();
if (oscui!=NULL) oscui->refresh();

hpbasetype->value(pars->Php.base.type);
hpbasepar1->value(pars->Php.base.par1);
hpfreqmult->value(pars->Php.freqmult);

hpmpar1->value(pars->Php.modulator.par1);
hpmfreq->value(pars->Php.modulator.freq);
hpwidth->value(pars->Php.width);

hponehalf->value(pars->Php.onehalf);
hpamptype->value(pars->Php.amp.type);
hpampmode->value(pars->Php.amp.mode);
hpamppar1->value(pars->Php.amp.par1);
hpamppar2->value(pars->Php.amp.par2);
hpautoscale->value(pars->Php.autoscale);

bwdial->value(pars->Pbandwidth);
if (pars->Pmode==0){
   bwprofilegroup->activate();
   bwdial->activate();
   bwcents->activate();
   hprofile->activate();
   hprofile->color(54);
   bwscale->activate();
} else {
   bwprofilegroup->deactivate();
   bwdial->deactivate();
   bwcents->deactivate();
   hprofile->deactivate();
   hprofile->color(48);
   bwscale->activate();
};

spectrummode->value(pars->Pmode);

qbasenote->value(pars->Pquality.basenote);
qsmpoct->value(pars->Pquality.smpoct);
qoct->value(pars->Pquality.oct);
qsamplesize->value(pars->Pquality.samplesize);

hrpostype->value(pars->Phrpos.type);
hrpospar1->value(pars->Phrpos.par1);
hrpospar2->value(pars->Phrpos.par2);
hrpospar3->value(pars->Phrpos.par3);

hprofile->redraw();
overtonepos->redraw();

osc->redraw();
pars->applyparameters(true);
applybutton->color(FL_GRAY);
applybutton->parent()->redraw();
}

PADnoteUI::~PADnoteUI() {
  delete(oscui);
delete(resui);

padnotewindow->hide();
delete(padnotewindow);
}
